#include <stdio.h>
#include <io.h>
#include <string.h>

/*t@C1CtH_2łȂ0Ԃ*/
int checkObj(struct _finddata_t *object)
{
	//printf("%s <<%02x>>\n",object->name,object->attrib);
	if (strcmp(object->name,".")==0) return 0;
	if (strcmp(object->name,"..")==0) return 0;
	if ((object->attrib&_A_SUBDIR)) return 2;
	if ((object->attrib&(_A_HIDDEN|_A_SYSTEM))) return 0;
	return 1;
}

/*
pathƒTIuWFNgselect^āCIuWFNgobjectnameԂB
P,sOԂB
select 1:t@CC2GfBNg
*/
int getobject(char *path, char *objectname, int select)
{
	struct _finddata_t object;
	static long   hFile=-1L;
	char dir[256]="";       /*KvȏꍇŌ\Ă (ċÂ)*/
	char nextdir[256]="";   /*Ɨ̈*/
	char searchstr[256]=""; /*p@Ō*.* */
	int flag=1;             /*tH_ɂȂɂ1CȂ0*/

	if (hFile==-1L) {
		if (strlen(path)==0) { /*Jg[gΏ*/
			/*path͂̂܂""*/
			strcpy(searchstr,"*.*");
		} else if (path[strlen(path)-1]!='\\') { /*\łȂ*/
			strcpy(dir,path);
			strcat(dir,"\\");
			strcpy(searchstr,dir);
			strcat(searchstr,"*.*");
		} else { /*\*/
			strcpy(dir,path);
			strcpy(searchstr,path);
			strcat(searchstr,"*.*");
		}
		if( (hFile = _findfirst( searchstr, &object )) == -1L ) {
			//printLevel(level,1); //ɗ邱Ƃ͂肦Ȃ
			//printf( "**ł\n" );
			return 0;
		} else {
			if (checkObj(&object)==select) {
				strcpy(objectname,object.name);
				return 1;
			}
		}
	}
	// c̃IuWFNgT܂
	while( _findnext( hFile, &object ) == 0 ){
		if (checkObj(&object)==select) {
			strcpy(objectname,object.name);
			return 1;
		}
	}
	_findclose( hFile );
	hFile=-1L;
	return 0;
}

char levelmark[256]="|";
int llflag=0;

void printLevel(int level,int terminated)
{
	int i;
	for (i=0; i<level-1; i++) printf(" %c ",levelmark[i]);
	if (terminated) printf(" `-");
	else printf(" |-");
}

void printLevelline(int level)
{
	int i;
	for (i=0; i<level; i++) printf(" %c ",levelmark[i]);
	printf("\n");
}

int listDir(char *orgdir, int level)
{
	char dir[256]="";       /*KvȏꍇŌ\Ă (ċÂ)*/
	char nextdir[256]="";   /*Ɨ̈*/
	char name[256];
	char **objectname;
	
	int nFolder=0;
	int nFile=0;
	int ntotal;
	int cnt=0;
	int childntotal;
	int i;

	if (strlen(orgdir)==0) { /*Jg[gΏ*/
		/*dir͂̂܂""*/
	} else if (dir[strlen(orgdir)-1]!='\\') { /*\łȂ*/
		strcpy(dir,orgdir);
		strcat(dir,"\\");
	} else { /*\*/
		strcpy(dir,orgdir);
	}

	//fBNgitH_jJEg܂B
	//printf(">>> search dir=%s\n",dir);
	while(getobject(dir,name,2)) nFolder++;
	//t@CJEg܂B
	while(getobject(dir,name,1)) nFile++;
	ntotal=nFolder+nFile;
	//printf(">>> nFolder, nFile, ntotal=%d %d %d\n",nFolder, nFile, ntotal);
	
	objectname=(char **)malloc(sizeof(char *)*ntotal);

	cnt=0;
	while (getobject(dir,name,2)) {
		objectname[cnt]=(char *)malloc(strlen(name)+4);
		strcpy(objectname[cnt],name);
		cnt++;
		//printf(">>> folder [%s]\n",name);
	}
	while (getobject(dir,name,1)) {
		objectname[cnt]=(char *)malloc(strlen(name)+4);
		strcpy(objectname[cnt],name);
		cnt++;
		//printf(">>> file [%s]\n",name);
	}

	cnt=0;
	for (i=0; i<nFolder; i++,cnt++) {
		if (cnt==ntotal-1) {
			levelmark[level-1]=' ';
			printLevel(level,1);
		} else {
			levelmark[level-1]='|';
			printLevel(level,0);
		}
		printf( "[folder] %s\n", objectname[cnt]);
		llflag=0;
		strcpy(nextdir,dir);
		strcat(nextdir,objectname[cnt]);
		childntotal=listDir(nextdir,level+1);
		if (childntotal && llflag==0) {
			printLevelline(level);
			llflag=1;
		}
	}
	for (i=0; i<nFile; i++,cnt++) {
		if (cnt==ntotal-1) {
			printLevel(level,1);
		} else {
			printLevel(level,0);
		}
		printf( "%s\n", objectname[cnt]);
		llflag=0;
	}
	for (i=0; i<ntotal; i++) free(objectname[i]);
	free(objectname);
	return ntotal;
}

int main(int argc, char *argv[])
{
	char dir[256]="";
	//char name[256];
	if (argc==2) {
		strcpy(dir,argv[1]);
	}
	if (strlen(dir)!=0) printf("%s\n",dir);
	else system("cd"); //print current directory
	//while(getobject(dir,name,2)) printf("folder %s\n",name);
	//while(getobject(dir,name,1)) printf("file   %s\n",name);
	//return 0;
	listDir(dir,1);
	getchar();
	return 0;
}

